> This page is for Developer Documentation.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.benchling.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.benchling.com/_mcp/server.

# Bulk create Features

POST https://{tenant_name}.benchling.com/api/v2/features:bulk-create
Content-Type: application/json

Bulk create Features

Reference: https://docs.benchling.com/docs/api/v2/benchling-api/feature-libraries/bulk-create-features

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Body (application/json)

This endpoint expects a FeaturesBulkCreateRequest.

- `features` (list of FeatureBulkCreate, optional)

## Response

### 202

This endpoint launches a [long-running task](#/Tasks/getTask) and returns the Task ID of the launched task. The task response contains the full list of features that were created.

- `taskId` (string, optional)

## Errors

### 400 Bad Request Error

Bad Request

- `error` (BadRequestErrorError, optional)

## Types

### FeatureBulkCreate

Inputs for a new feature

- `featureLibraryId` (string, required) — The id of the feature library the feature belongs to
- `featureType` (string, required, nullable) — The type of feature, like gene, promoter, etc. Note: This is an arbitrary string, not an enum
- `name` (string, required) — The name of the feature
- `pattern` (string, required) — The pattern used for matching during auto-annotation.
- `matchType` (enum, required) — The match type of the feature. Used to determine how auto-annotate matches are made.
  - Allowed values: `nucleotide`, `protein`
- `color` (string, optional) — The color of the annotations generated by the feature. Must be a valid hex string

### BadRequestErrorError

- `message` (string, optional)
- `type` (enum, optional)
  - Allowed values: `invalid_request_error`
- `userMessage` (string, optional)

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "taskId": "string"
}
```

**SDK Code**

```python
import requests

url = "https://{tenant_name}.benchling.com/api/v2/features:bulk-create"

payload = {}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://{tenant_name}.benchling.com/api/v2/features:bulk-create';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```